<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Modélisation UML</title>
    <link rel="stylesheet" href="./styleUmlPage.css">
    <link rel="stylesheet" href="../mainArticleStyle.css">
    <script src="../mainArticleScript.js"></script>
    <link rel="icon" type="image/svg" href="../img/cloud-snow.svg" />

</head>
<body>
    <header>
        <section class="headerContent">
            <span class="headerLink "><a href="../index.html"><img class="homeSvg" alt="Accueil" src="../img/home.svg"></a></span>
            <span class="headerLink active"><a href="umlPage.html">Modélisation UML</a></span>
            <span class="headerLink "><a href="../ihmPage/imhPage.html">Interfaces utilisateur</a></span>
            <span class="headerLink "><a href="../devPage/devPage.html">Développement Android</a></span>
        </section>
    </header>
    <main>
        <span class="touchBar"></span>
        
        <h1 class="pageTitle">Modélisation UML</h1>

        <div class="card fullWidth">
            <div class="cardHeader secondColor">Introduction</div>
            <div class="cardContent intro">
                <p class="textContent">
                    Le Langage de Modélisation Unifié, de l'anglais Unified Modeling Language (UML), est un <b>langage de modélisation graphique</b> à base de pictogrammes conçu pour fournir une méthode normalisée pour <b>visualiser la conception d'un système</b>. Il est couramment utilisé en développement logiciel et en conception orientée objet. L'UML est le résultat de la fusion de précédents langages de modélisation objet : <i>Booch, OMT, OOSE</i>. Principalement issu des travaux de Grady Booch, James Rumbaugh et Ivar Jacobson, UML est à présent un standard adopté par l'Object Management Group (OMG). UML 1.0 a été normalisé en janvier 1997; UML 2.0 a été adopté par l'OMG en juillet 2005. La dernière version de la spécification validée par l'OMG est UML 2.5.1 (2017). Un pictogramme, également appelé pictographe, est une représentation graphique schématique, un dessin figuratif stylisé ayant fonction de signe. Dans toutes les langues du monde avec un système graphique, le pictogramme sert à expliquer une information d'ordre général.
                    <br>
                    <br>
                    Les vues statiques, c'est-à-dire représentant le système physiquement :
                    <ul>
                        <li>diagrammes d'objets</li>
                        <li>diagrammes de cas d'utilisation</li>
                        <li>diagrammes de composants</li>
                        <li>diagrammes de déploiement</li>
                    </ul>

                    Les vues dynamiques, montrant le fonctionnement du système :
                    <ul>
                        <li>diagrammes de séquence</li>
                        <li>diagrammes d’interactions</li>
                        <li>diagrammes d'états-transitions</li>
                        <li>diagrammes d'activités</li>

                    </ul>
                </p>
            </div>
        </div>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Diagrammes d’objets</div>
                <div class="cardContent">
                    <p class="textContent">
                        Le diagramme d'objets, dans le langage de modélisation de données UML, permet de représenter les instances des classes, c'est-à-dire des objets. Comme le diagramme de classes, il exprime les relations qui existent entre les objets, mais aussi l'état des objets, ce qui permet d'exprimer des contextes d'exécution. En ce sens, ce diagramme est moins général que le diagramme de classes.
                        <br>
                        <br>
                        Les diagrammes d'objets s'utilisent pour montrer l'état des instances d'objet avant et après une interaction, autrement dit c'est une photographie à un instant précis des attributs et objets existants. Il est utilisé en phase exploratoire.

                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <img style="width: 650px;" src="../img/Object_diagram.png" alt="Image de diagramme">
                </div>
            </div>
        </section>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Diagramme de cas d’utilisation</div>
                <div class="cardContent">
                    <p class="textContent">
                        Afin de ne pas perdre de vue les fonctionnalités offertes par le système complet, le langage SysML décrit ce qui est appelé les "cas d'utilisation".
                        <br>
                        <br>
                        C'est la réponse à la question : "quels services rend le système ?"
                        <br>
                        <br>
                        On retrouve sur ce diagramme les éléments suivants :<br>
                        <ul>
                            <li>acteur(s)</li>
                            <li>relation(s) entre acteur(s) et le système</li>
                            <li>frontière du système</li>
                            <li>fonction globale du système</li>
                        </ul>
                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <img style="width: 650px;" src="../img/fig2_5.png" alt="Image de diagramme">
                </div>
            </div>
        </section>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Diagramme de composants</div>
                <div class="cardContent">
                    <p class="textContent">
                        Un diagramme de composants a pour objectif d'illustrer la relation entre les différents composants d'un système. Dans le cadre de l'UML 2.0, le terme « composant » fait référence à un module de classes qui représentent des systèmes ou des sous-systèmes indépendants ayant la capacité de s'interfacer avec le reste du système. <br><br>
                        Il existe une approche de développement entièrement articulée autour des composants: la programmation orientée composant (POC). Dans cette approche, les diagrammes de composants permettent au responsable de la planification d'identifier les différents composants afin que l'ensemble du système fonctionne selon le cahier des charges. <br><br>
                        Plus communément, dans une approche de programmation orientée objet, le diagramme de composants permet à un développeur senior de regrouper des classes autour d'un objectif commun afin que les parties prenantes et lui-même puissent disposer d'une vue d'ensemble sur un projet de développement logiciel.

                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <img style="width: 650px;" src="../img/component-diagram-example-497x318.PNG" alt="Image de diagramme">
                </div>
            </div>
        </section>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Diagrammes de déploiements</div>
                <div class="cardContent">
                    <p class="textContent">
                        Dans le contexte du langage de modélisation unifié (UML), un diagramme de déploiement fait partie de la catégorie des diagrammes structurels, car il décrit un aspect du système même. Dans le cas présent, le diagramme de déploiement décrit le déploiement physique des informations générées par le logiciel sur des composants matériels. On appelle artefact l'information qui est générée par le logiciel. Attention, ne confondez pas cette utilisation du terme avec celle qui existe dans d'autres approches de modélisation comme le BPMN. <br><br>
                        Les diagrammes de déploiement sont constitués de plusieurs formes UML. Les boîtes en trois dimensions, appelées nœuds, représentent les composants du système, qu'ils soient logiciels ou matériels. Les lignes entre les nœuds indiquent les relations et les petites formes à l'intérieur des boîtes représentent les artefacts logiciels qui sont déployés

                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <img style="width: 650px;" src="../img/deployment_diagram_real_estate-700x573.png" alt="Image de diagramme">
                </div>
            </div>
        </section>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Diagrammes de séquence</div>
                <div class="cardContent">
                    <p class="textContent">
                        Un diagramme de séquence est un type de diagramme d'interaction, car il décrit comment et dans quel ordre plusieurs objets fonctionnent ensemble. Ces diagrammes sont utilisés à la fois par les développeurs logiciels et les managers d'entreprises pour analyser les besoins d'un nouveau système ou documenter un processus existant. Les diagrammes de séquence sont parfois appelés diagrammes d'événements ou scénarios d'événements.
                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <img style="width: 650px;" src="../img/350px-Restaurant_UML_SEQ.svg.png" alt="Image de diagramme">
                </div>
            </div>
        </section>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Diagrammes d’interactions</div>
                <div class="cardContent">
                    <p class="textContent">
                        Un objet interagit pour implémenter un comportement. On peut décrire cette interaction de deux manières complémentaires : l'une est centrée sur des objets individuels (diagramme d'états-transitions) et l'autre sur une collection d'objets qui coopèrent (diagrammes d'interaction). <br><br>
                        La spécification d'un diagramme d'états-transitions est précise et conduit immédiatement au code. Elle ne permet pas pour autant d'expliquer le fonctionnement global d'un système, car elle se concentre sur un seul objet à la fois. Un diagramme d'interaction permet d'offrir une vue plus holistique du comportement d'un jeu d'objets. <br><br>
                        Le diagramme de communication est un diagramme d'interaction mettant l'accent sur l'organisation structurelle des objets qui envoient et reçoivent des messages. Le diagramme de séquence est un diagramme d'interaction mettant l'accent sur la chronologie de l'envoi des messages. Les diagrammes d'interaction permettent d'établir un lien entre les diagrammes de cas d'utilisation et les diagrammes de classes : ils montrent comment des objets (i.e. des instances de classe) communiquent pour réaliser une certaine fonctionnalité. Ils apportent ainsi un aspect dynamique à la modélisation du système.
                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <img style="width: 650px;" src="../img/UML-Interaction-Overview-Diagram@2x.png" alt="Image de diagramme">
                </div>
            </div>
        </section>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Diagrammes d’état de transitions</div>
                <div class="cardContent">
                    <p class="textContent">
                        Un automate désigne tout appareil qui enregistre l'état d’un objet à un moment donné et peut changer l'état ou provoquer d'autres actions selon les informations qu’il reçoit. Les états correspondent aux différentes combinaisons d'informations qu'un objet peut contenir et non la façon dont celui-ci se comporte. Pour comprendre les différents états d’un objet, vous pouvez visualiser tous les états possibles et montrer comment un objet parvient à chaque état à l'aide d'un diagramme d'état transition UML. <br><br>

                        Un diagramme d'état transition commence généralement par un rond noir qui indique l'état initial et se termine par un rond cerclé indiquant l'état final. Toutefois, bien qu'ils aient des points de départ et des extrémités bien définis, les diagrammes d'états-transitions ne sont pas forcément le meilleur outil pour représenter la progression d'une série d'événements. Ils sont plutôt indiqués pour illustrer des types de comportements spécifiques, notamment les changements d'état.

                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <img style="width: 650px;" src="../img/state_diagram_basic_example-500x281.PNG" alt="Image de diagramme">
                </div>
            </div>
        </section>

        <section class="linkedCards">
            <div class="card">
                <div class="cardHeader">Diagrammes d’activités</div>
                <div class="cardContent">
                    <p class="textContent">
                        Dans le langage UML, un diagramme d'activité fournit une vue du comportement d'un système en décrivant la séquence d'actions d'un processus. Les diagrammes d'activité sont similaires aux organigrammes de traitement de l'information, car ils montrent les flux entre les actions dans une activité. Les diagrammes d'activité peuvent, cependant, aussi montrer les flux parallèles simultanés et les flux de remplacement. <br><br>
                        Dans les diagrammes d'activité, vous utilisez des nœuds d'activité et des bords d'activité pour modéliser le flux de commande et de données entre les actions. <br><br>
                        Les diagrammes d'activité sont utiles dans les phases suivantes d'un projet :

                        <ul>
                            <li>Avant de démarrer un projet, vous pouvez créer des diagrammes d'activité pour modéliser les principaux flux de travaux.</li>
                            <li>Pendant la phase d'exigences, vous pouvez créer des diagrammes d'activité pour illustrer le flux d'événements décrit dans les cas d'utilisation.</li>
                            <li>Pendant les phases d'analyse et de conception, vous pouvez utiliser des diagrammes d'activité pour faciliter la définition du comportement des opérations.</li>
                        </ul>
                    </p>
                </div>
            </div>

            <div class="link"></div>

            <div class="card">
                <div class="cardHeader">
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                    <span class="windowAction"></span>
                </div>
                <div class="cardContent">
                    <img style="width: 650px;" src="../img/activity-diagram-for-banking-system-UML-650x665.png" alt="Image de diagramme">
                </div>
            </div>
        </section>

        


        <button class="adviceButton" onclick="displayAdvice()"><img class="homeSvg" alt="Accueil" src="../img/info.svg"></button>

        <div class="card advice hidden" id="advice">
            <div class="cardHeader"><img onclick="hideAdvice()" class="windowAction close" alt="Accueil" src="../img/x-circle.svg">Anecdote</div>
            <div class="cardContent">
                <p class="textContent">
                    Il existe beaucoup de diagrammes
                    <br>
                    <br>
                    <h3>Sources</h5>
                    <ul>
                        <li>Wikipedia</li>
                        <li>Lucidchart</li>
                        <li>La culture G</li>
                    </ul>
                </p>
            </div>
        </div>

    </main>
    <footer>
        <section class="footerContent">
            <h6>All right reserved | Copyright © 2022 CHAPUIS DEPRECQ</h6>
        </section>
    </footer>
</body>
</html>
